;; Basic Roma-to-Kana Translation Table for Egg
;; Coded by S.Tomura, Electrotechnical Lab. (tomura@etl.go.jp)

;; This file is part of Egg on Nemacs (Japanese Environment)

;; Egg is distributed in the forms of patches to GNU
;; Emacs under the terms of the GNU EMACS GENERAL PUBLIC
;; LICENSE which is distributed along with GNU Emacs by the
;; Free Software Foundation.

;; Egg is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied
;; warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
;; PURPOSE.  See the GNU EMACS GENERAL PUBLIC LICENSE for
;; more details.

;; You should have received a copy of the GNU EMACS GENERAL
;; PUBLIC LICENSE along with Nemacs; see the file COPYING.
;; If not, write to the Free Software Foundation, 675 Mass
;; Ave, Cambridge, MA 02139, USA.

(defun its:select-quanjiao-downcase () (interactive) (its:select-mode "quanjiao-downcase"))
(define-key mule-keymap "\C-d" 'its:select-quanjiao-downcase)
(define-key fence-mode-map "\eq" 'its:select-quanjiao-downcase)

(its-define-mode "quanjiao-downcase" "$A#a(B" t nil nil 'cserver)

(mapcar (lambda (pair) (its-defrule (car pair) (cdr pair)))
	'((" " . "$A!!(B") ("!" . "$A#!(B") ("\"". "$A#"(B") ("#" . "$A##(B") ("$" . "$A#$(B")
	  ("%" . "$A#%(B") ("&" . "$A#&(B") ("'" . "$A#'(B") ("(" . "$A#((B") (")" . "$A#)(B")
	  ("*" . "$A#*(B") ("+" . "$A#+(B") ("," . "$A#,(B") ("-" . "$A#-(B") ("." . "$A#.(B")
	  ("/" . "$A#/(B")
	  ("0" . "$A#0(B") ("1" . "$A#1(B") ("2" . "$A#2(B") ("3" . "$A#3(B") ("4" . "$A#4(B")
	  ("5" . "$A#5(B") ("6" . "$A#6(B") ("7" . "$A#7(B") ("8" . "$A#8(B") ("9" . "$A#9(B")
	  (":" . "$A#:(B") (";" . "$A#;(B") ("<" . "$A#<(B") ("=" . "$A#=(B") (">" . "$A#>(B")
	  ("?" . "$A#?(B")
	  ("@" . "$A#@(B")
	  ("A" . "$A#A(B") ("B" . "$A#B(B") ("C" . "$A#C(B") ("D" . "$A#D(B") ("E" . "$A#E(B")
	  ("F" . "$A#F(B") ("G" . "$A#G(B") ("H" . "$A#H(B") ("I" . "$A#I(B") ("J" . "$A#J(B")
	  ("K" . "$A#K(B") ("L" . "$A#L(B") ("M" . "$A#M(B") ("N" . "$A#N(B") ("O" . "$A#O(B")
	  ("P" . "$A#P(B") ("Q" . "$A#Q(B") ("R" . "$A#R(B") ("S" . "$A#S(B") ("T" . "$A#T(B")
	  ("U" . "$A#U(B") ("V" . "$A#V(B") ("W" . "$A#W(B") ("X" . "$A#X(B") ("Y" . "$A#Y(B")
	  ("Z" . "$A#Z(B")
	  ("[" . "$A#[(B") ("\\". "$A#\(B") ("]" . "$A#](B") ("^" . "$A#^(B") ("_" . "$A#_(B")
	  ("`" . "$A#`(B")
	  ("a" . "$A#a(B") ("b" . "$A#b(B") ("c" . "$A#c(B") ("d" . "$A#d(B") ("e" . "$A#e(B")
	  ("f" . "$A#f(B") ("g" . "$A#g(B") ("h" . "$A#h(B") ("i" . "$A#i(B") ("j" . "$A#j(B")
	  ("k" . "$A#k(B") ("l" . "$A#l(B") ("m" . "$A#m(B") ("n" . "$A#n(B") ("o" . "$A#o(B")
	  ("p" . "$A#p(B") ("q" . "$A#q(B") ("r" . "$A#r(B") ("s" . "$A#s(B") ("t" . "$A#t(B")
	  ("u" . "$A#u(B") ("v" . "$A#v(B") ("w" . "$A#w(B") ("x" . "$A#x(B") ("y" . "$A#y(B")
	  ("z" . "$A#z(B")
	  ("{" . "$A#{(B") ("|" . "$A#|(B") ("}" . "$A#}(B") ("~" . "$A#~(B")))

;;;
;;;
;;;

(defun its:select-quanjiao-upcase () (interactive) (its:select-mode "quanjiao-upcase"))
(define-key mule-keymap "\C-u" 'its:select-quanjiao-upcase)
(define-key fence-mode-map "\eQ" 'its:select-quanjiao-upcase)

(its-define-mode "quanjiao-upcase"  "$A#A(B" t nil nil 'cserver)

(mapcar (lambda (pair)  (its-defrule (car pair) (cdr pair)))
	'((" " . "$A!!(B") ("!" . "$A#!(B") ("\"". "$A#"(B") ("#" . "$A##(B") ("$" . "$A#$(B")
	  ("%" . "$A#%(B") ("&" . "$A#&(B") ("'" . "$A#'(B") ("(" . "$A#((B") (")" . "$A#)(B")
	  ("*" . "$A#*(B") ("+" . "$A#+(B") ("," . "$A#,(B") ("-" . "$A#-(B") ("." . "$A#.(B")
	  ("/" . "$A#/(B")
	  ("0" . "$A#0(B") ("1" . "$A#1(B") ("2" . "$A#2(B") ("3" . "$A#3(B") ("4" . "$A#4(B")
	  ("5" . "$A#5(B") ("6" . "$A#6(B") ("7" . "$A#7(B") ("8" . "$A#8(B") ("9" . "$A#9(B")
	  (":" . "$A#:(B") (";" . "$A#;(B") ("<" . "$A#<(B") ("=" . "$A#=(B") (">" . "$A#>(B")
	  ("?" . "$A#?(B")
	  ("@" . "$A#@(B")
	  ("A" . "$A#A(B") ("B" . "$A#B(B") ("C" . "$A#C(B") ("D" . "$A#D(B") ("E" . "$A#E(B")
	  ("F" . "$A#F(B") ("G" . "$A#G(B") ("H" . "$A#H(B") ("I" . "$A#I(B") ("J" . "$A#J(B")
	  ("K" . "$A#K(B") ("L" . "$A#L(B") ("M" . "$A#M(B") ("N" . "$A#N(B") ("O" . "$A#O(B")
	  ("P" . "$A#P(B") ("Q" . "$A#Q(B") ("R" . "$A#R(B") ("S" . "$A#S(B") ("T" . "$A#T(B")
	  ("U" . "$A#U(B") ("V" . "$A#V(B") ("W" . "$A#W(B") ("X" . "$A#X(B") ("Y" . "$A#Y(B")
	  ("Z" . "$A#Z(B")
	  ("[" . "$A#[(B") ("\\". "$A#\(B") ("]" . "$A#](B") ("^" . "$A#^(B") ("_" . "$A#_(B")
	  ("`" . "$A#`(B")
	  ("a" . "$A#A(B") ("b" . "$A#B(B") ("c" . "$A#C(B") ("d" . "$A#D(B") ("e" . "$A#E(B")
	  ("f" . "$A#F(B") ("g" . "$A#G(B") ("h" . "$A#H(B") ("i" . "$A#I(B") ("j" . "$A#J(B")
	  ("k" . "$A#K(B") ("l" . "$A#L(B") ("m" . "$A#M(B") ("n" . "$A#N(B") ("o" . "$A#O(B")
	  ("p" . "$A#P(B") ("q" . "$A#Q(B") ("r" . "$A#R(B") ("s" . "$A#S(B") ("t" . "$A#T(B")
	  ("u" . "$A#U(B") ("v" . "$A#V(B") ("w" . "$A#W(B") ("x" . "$A#X(B") ("y" . "$A#Y(B")
	  ("z" . "$A#Z(B")
	  ("{" . "$A#{(B") ("|" . "$A#|(B") ("}" . "$A#}(B") ("~" . "$A#~(B")))
